Files
List files
get /files
Returns a list of files.
Query Parameters
-
after: optional stringA cursor for use in pagination.
afteris an object ID that defines your place in the list. For instance, if you make a list request and receive 100 objects, ending with obj_foo, your subsequent call can include after=obj_foo in order to fetch the next page of the list. -
limit: optional numberA limit on the number of objects to be returned. Limit can range between 1 and 10,000, and the default is 10,000.
-
order: optional "asc" or "desc"Sort order by the
created_attimestamp of the objects.ascfor ascending order anddescfor descending order.-
"asc" -
"desc"
-
-
purpose: optional stringOnly return files with the given purpose.
Returns
-
data: array of FileObject-
id: stringThe file identifier, which can be referenced in the API endpoints.
-
bytes: numberThe size of the file, in bytes.
-
created_at: numberThe Unix timestamp (in seconds) for when the file was created.
-
filename: stringThe name of the file.
-
object: "file"The object type, which is always
file."file"
-
purpose: "assistants" or "assistants_output" or "batch" or 5 moreThe intended purpose of the file. Supported values are
assistants,assistants_output,batch,batch_output,fine-tune,fine-tune-results,vision, anduser_data.-
"assistants" -
"assistants_output" -
"batch" -
"batch_output" -
"fine-tune" -
"fine-tune-results" -
"vision" -
"user_data"
-
-
status: "uploaded" or "processed" or "error"Deprecated. The current status of the file, which can be either
uploaded,processed, orerror.-
"uploaded" -
"processed" -
"error"
-
-
expires_at: optional numberThe Unix timestamp (in seconds) for when the file will expire.
-
status_details: optional stringDeprecated. For details on why a fine-tuning training file failed validation, see the
errorfield onfine_tuning.job.
-
-
first_id: string -
has_more: boolean -
last_id: string -
object: string
Example
curl https://api.openai.com/v1/files \
-H "Authorization: Bearer $OPENAI_API_KEY"
Response
{
"data": [
{
"id": "id",
"bytes": 0,
"created_at": 0,
"filename": "filename",
"object": "file",
"purpose": "assistants",
"status": "uploaded",
"expires_at": 0,
"status_details": "status_details"
}
],
"first_id": "file-abc123",
"has_more": false,
"last_id": "file-abc456",
"object": "list"
}
Example
curl https://api.openai.com/v1/files \
-H "Authorization: Bearer $OPENAI_API_KEY"
Response
{
"object": "list",
"data": [
{
"id": "file-abc123",
"object": "file",
"bytes": 175,
"created_at": 1613677385,
"expires_at": 1677614202,
"filename": "salesOverview.pdf",
"purpose": "assistants",
},
{
"id": "file-abc456",
"object": "file",
"bytes": 140,
"created_at": 1613779121,
"expires_at": 1677614202,
"filename": "puppy.jsonl",
"purpose": "fine-tune",
}
],
"first_id": "file-abc123",
"last_id": "file-abc456",
"has_more": false
}
Upload file
post /files
Upload a file that can be used across various endpoints. Individual files can be up to 512 MB, and each project can store up to 2.5 TB of files in total. There is no organization-wide storage limit. Uploads to this endpoint are rate-limited to 1,000 requests per minute per authenticated user.
- The Assistants API supports files up to 2 million tokens and of specific file types. See the Assistants Tools guide for details.
- The Fine-tuning API only supports
.jsonlfiles. The input also has certain required formats for fine-tuning chat or completions models. - The Batch API only supports
.jsonlfiles up to 200 MB in size. The input also has a specific required format. - For Retrieval or
file_searchingestion, upload files here first. If you need to attach multiple uploaded files to the same vector store, use/vector_stores/{vector_store_id}/file_batchesinstead of attaching them one by one. Vector store attachment has separate limits from file upload, including 2,000 attached files per minute per organization.
Please contact us if you need to increase these storage limits.
Returns
-
FileObject object { id, bytes, created_at, 6 more }The
Fileobject represents a document that has been uploaded to OpenAI.-
id: stringThe file identifier, which can be referenced in the API endpoints.
-
bytes: numberThe size of the file, in bytes.
-
created_at: numberThe Unix timestamp (in seconds) for when the file was created.
-
filename: stringThe name of the file.
-
object: "file"The object type, which is always
file."file"
-
purpose: "assistants" or "assistants_output" or "batch" or 5 moreThe intended purpose of the file. Supported values are
assistants,assistants_output,batch,batch_output,fine-tune,fine-tune-results,vision, anduser_data.-
"assistants" -
"assistants_output" -
"batch" -
"batch_output" -
"fine-tune" -
"fine-tune-results" -
"vision" -
"user_data"
-
-
status: "uploaded" or "processed" or "error"Deprecated. The current status of the file, which can be either
uploaded,processed, orerror.-
"uploaded" -
"processed" -
"error"
-
-
expires_at: optional numberThe Unix timestamp (in seconds) for when the file will expire.
-
status_details: optional stringDeprecated. For details on why a fine-tuning training file failed validation, see the
errorfield onfine_tuning.job.
-
Example
curl https://api.openai.com/v1/files \
-H 'Content-Type: multipart/form-data' \
-H "Authorization: Bearer $OPENAI_API_KEY" \
-F 'file=@/path/to/file' \
-F purpose=assistants
Response
{
"id": "id",
"bytes": 0,
"created_at": 0,
"filename": "filename",
"object": "file",
"purpose": "assistants",
"status": "uploaded",
"expires_at": 0,
"status_details": "status_details"
}
Example
curl https://api.openai.com/v1/files \
-H "Authorization: Bearer $OPENAI_API_KEY" \
-F purpose="fine-tune" \
-F file="@mydata.jsonl"
-F expires_after[anchor]="created_at"
-F expires_after[seconds]=2592000
Response
{
"id": "file-abc123",
"object": "file",
"bytes": 120000,
"created_at": 1677610602,
"expires_at": 1677614202,
"filename": "mydata.jsonl",
"purpose": "fine-tune",
}
Delete file
delete /files/{file_id}
Delete a file and remove it from all vector stores.
Path Parameters
file_id: string
Returns
-
FileDeleted object { id, deleted, object }-
id: string -
deleted: boolean -
object: "file""file"
-
Example
curl https://api.openai.com/v1/files/$FILE_ID \
-X DELETE \
-H "Authorization: Bearer $OPENAI_API_KEY"
Response
{
"id": "id",
"deleted": true,
"object": "file"
}
Example
curl https://api.openai.com/v1/files/file-abc123 \
-X DELETE \
-H "Authorization: Bearer $OPENAI_API_KEY"
Response
{
"id": "file-abc123",
"object": "file",
"deleted": true
}
Retrieve file
get /files/{file_id}
Returns information about a specific file.
Path Parameters
file_id: string
Returns
-
FileObject object { id, bytes, created_at, 6 more }The
Fileobject represents a document that has been uploaded to OpenAI.-
id: stringThe file identifier, which can be referenced in the API endpoints.
-
bytes: numberThe size of the file, in bytes.
-
created_at: numberThe Unix timestamp (in seconds) for when the file was created.
-
filename: stringThe name of the file.
-
object: "file"The object type, which is always
file."file"
-
purpose: "assistants" or "assistants_output" or "batch" or 5 moreThe intended purpose of the file. Supported values are
assistants,assistants_output,batch,batch_output,fine-tune,fine-tune-results,vision, anduser_data.-
"assistants" -
"assistants_output" -
"batch" -
"batch_output" -
"fine-tune" -
"fine-tune-results" -
"vision" -
"user_data"
-
-
status: "uploaded" or "processed" or "error"Deprecated. The current status of the file, which can be either
uploaded,processed, orerror.-
"uploaded" -
"processed" -
"error"
-
-
expires_at: optional numberThe Unix timestamp (in seconds) for when the file will expire.
-
status_details: optional stringDeprecated. For details on why a fine-tuning training file failed validation, see the
errorfield onfine_tuning.job.
-
Example
curl https://api.openai.com/v1/files/$FILE_ID \
-H "Authorization: Bearer $OPENAI_API_KEY"
Response
{
"id": "id",
"bytes": 0,
"created_at": 0,
"filename": "filename",
"object": "file",
"purpose": "assistants",
"status": "uploaded",
"expires_at": 0,
"status_details": "status_details"
}
Example
curl https://api.openai.com/v1/files/file-abc123 \
-H "Authorization: Bearer $OPENAI_API_KEY"
Response
{
"id": "file-abc123",
"object": "file",
"bytes": 120000,
"created_at": 1677610602,
"expires_at": 1677614202,
"filename": "mydata.jsonl",
"purpose": "fine-tune",
}
Retrieve file content
get /files/{file_id}/content
Returns the contents of the specified file.
Path Parameters
file_id: string
Example
curl https://api.openai.com/v1/files/$FILE_ID/content \
-H "Authorization: Bearer $OPENAI_API_KEY"
Example
curl https://api.openai.com/v1/files/file-abc123/content \
-H "Authorization: Bearer $OPENAI_API_KEY" > file.jsonl
Domain Types
File Content
FileContent = string
File Deleted
-
FileDeleted object { id, deleted, object }-
id: string -
deleted: boolean -
object: "file""file"
-
File Object
-
FileObject object { id, bytes, created_at, 6 more }The
Fileobject represents a document that has been uploaded to OpenAI.-
id: stringThe file identifier, which can be referenced in the API endpoints.
-
bytes: numberThe size of the file, in bytes.
-
created_at: numberThe Unix timestamp (in seconds) for when the file was created.
-
filename: stringThe name of the file.
-
object: "file"The object type, which is always
file."file"
-
purpose: "assistants" or "assistants_output" or "batch" or 5 moreThe intended purpose of the file. Supported values are
assistants,assistants_output,batch,batch_output,fine-tune,fine-tune-results,vision, anduser_data.-
"assistants" -
"assistants_output" -
"batch" -
"batch_output" -
"fine-tune" -
"fine-tune-results" -
"vision" -
"user_data"
-
-
status: "uploaded" or "processed" or "error"Deprecated. The current status of the file, which can be either
uploaded,processed, orerror.-
"uploaded" -
"processed" -
"error"
-
-
expires_at: optional numberThe Unix timestamp (in seconds) for when the file will expire.
-
status_details: optional stringDeprecated. For details on why a fine-tuning training file failed validation, see the
errorfield onfine_tuning.job.
-